import _defineProperty from "@babel/runtime-corejs3/helpers/esm/defineProperty";
import { hasElementSourceMap, toValue } from '@swagger-api/apidom-core';
import JsonPointerError from "./JsonPointerError.js";
class EvaluationJsonPointerError extends JsonPointerError {
  constructor(message, structuredOptions) {
    super(message, structuredOptions);
    _defineProperty(this, "pointer", void 0);
    _defineProperty(this, "tokens", void 0);
    _defineProperty(this, "failedToken", void 0);
    _defineProperty(this, "failedTokenPosition", void 0);
    _defineProperty(this, "element", void 0);
    _defineProperty(this, "elementSourceMap", void 0);
    if (typeof structuredOptions !== 'undefined') {
      this.pointer = structuredOptions.pointer;
      if (Array.isArray(structuredOptions.tokens)) {
        this.tokens = [...structuredOptions.tokens];
      }
      this.failedToken = structuredOptions.failedToken;
      this.failedTokenPosition = structuredOptions.failedTokenPosition;
      this.element = structuredOptions.element.element;
      if (hasElementSourceMap(structuredOptions.element)) {
        this.elementSourceMap = toValue(structuredOptions.element.getMetaProperty('sourceMap'));
      }
    }
  }
}
export default EvaluationJsonPointerError;